diff --git a/xrdp/xrdp_login_wnd.c b/xrdp/xrdp_login_wnd.c
index 784c06f..b38f93c 100644
--- a/xrdp/xrdp_login_wnd.c
+++ b/xrdp/xrdp_login_wnd.c
@@ -205,7 +205,12 @@ xrdp_wm_ok_clicked(struct xrdp_bitmap* wnd)
       edit = xrdp_bitmap_get_child_by_id(wnd, i + 1);
       while (label != 0 && edit != 0)
       {
-        set_mod_data_item(mod_data, label->caption1, edit->caption1);
+	if (g_strcmp (label->caption1, "User name:") == 0)
+          set_mod_data_item(mod_data, "username", edit->caption1);
+	else if (g_strcmp (label->caption1, "Password:") == 0)
+          set_mod_data_item(mod_data, "password", edit->caption1);
+	else
+          set_mod_data_item(mod_data, label->caption1, edit->caption1);
         i += 2;
         label = xrdp_bitmap_get_child_by_id(wnd, i);
         edit = xrdp_bitmap_get_child_by_id(wnd, i + 1);
@@ -268,21 +273,24 @@ xrdp_wm_show_edits(struct xrdp_wm* self, struct xrdp_bitmap* combo)
         insert_index++;
         b->parent = self->login_window;
         b->owner = self->login_window;
-        b->left = 155;
-        b->top = 60 + 25 * count;
+        b->left = 16;
+        b->top = 159 + 25 * count;
         b->id = 100 + 2 * count;
         name = (char*)list_get_item(mod->names, index);
-        set_string(&b->caption1, name);
+        if (g_strcmp (name, "username") == 0)
+          set_string(&b->caption1, "User name:");
+        else
+          set_string(&b->caption1, "Password:");
         /* edit */
-        b = xrdp_bitmap_create(140, 20, self->screen->bpp,
+        b = xrdp_bitmap_create(self->login_window->width - 200, 20, self->screen->bpp,
                                WND_TYPE_EDIT, self);
         list_insert_item(self->login_window->child_list, insert_index,
                               (long)b);
         insert_index++;
         b->parent = self->login_window;
         b->owner = self->login_window;
-        b->left = 230;
-        b->top = 60 + 25 * count;
+        b->left = 100;
+        b->top = 159 + 25 * count;
         b->id = 100 + 2 * count + 1;
         b->pointer = 1;
         b->tab_stop = 1;
@@ -370,7 +378,6 @@ xrdp_wm_login_notify(struct xrdp_bitmap* wnd,
   }
   else if (msg == CB_ITEMCHANGE) /* combo box change */
   {
-    xrdp_wm_show_edits(wnd->wm, sender);
     xrdp_bitmap_invalidate(wnd, 0); /* invalidate the whole dialog for now */
   }
   return 0;
@@ -380,62 +387,7 @@ xrdp_wm_login_notify(struct xrdp_bitmap* wnd,
 static int APP_CC
 xrdp_wm_login_fill_in_combo(struct xrdp_wm* self, struct xrdp_bitmap* b)
 {
-  struct list* sections;
-  struct list* section_names;
-  struct list* section_values;
-  int fd;
-  int i;
-  int j;
-  char* p;
-  char* q;
-  char* r;
-  char name[256];
-  struct xrdp_mod_data* mod_data;
-
-  sections = list_create();
-  sections->auto_free = 1;
-  section_names = list_create();
-  section_names->auto_free = 1;
-  section_values = list_create();
-  section_values->auto_free = 1;
-  fd = g_file_open(XRDP_CFG_FILE); /* xrdp.ini */
-  file_read_sections(fd, sections);
-  for (i = 0; i < sections->count; i++)
-  {
-    p = (char*)list_get_item(sections, i);
-    file_read_section(fd, p, section_names, section_values);
-    if (g_strncmp(p, "globals", 255) == 0)
-    {
-    }
-    else
-    {
-      g_strncpy(name, p, 255);
-      mod_data = (struct xrdp_mod_data*)
-                     g_malloc(sizeof(struct xrdp_mod_data), 1);
-      mod_data->names = list_create();
-      mod_data->names->auto_free = 1;
-      mod_data->values = list_create();
-      mod_data->values->auto_free = 1;
-      for (j = 0; j < section_names->count; j++)
-      {
-        q = (char*)list_get_item(section_names, j);
-        r = (char*)list_get_item(section_values, j);
-        if (g_strncmp("name", q, 255) == 0)
-        {
-          g_strncpy(name, r, 255);
-        }
-        list_add_item(mod_data->names, (long)g_strdup(q));
-        list_add_item(mod_data->values, (long)g_strdup(r));
-      }
-      list_add_item(b->string_list, (long)g_strdup(name));
-      list_add_item(b->data_list, (long)mod_data);
-    }
-  }
-  g_file_close(fd);
-  list_delete(sections);
-  list_delete(section_names);
-  list_delete(section_values);
-  return 0;
+  return xrdp_wm_load_sections(self, b->string_list, b->data_list);
 }
 
 /******************************************************************************/
@@ -445,11 +397,19 @@ xrdp_login_wnd_create(struct xrdp_wm* self)
   struct xrdp_bitmap* but;
   struct xrdp_bitmap* combo;
   char file_path[256];
+  char hostname[256];
+  char title[288];
+  int i;
+
+  g_strncpy(hostname, "xrdp", 255);
+  g_gethostname(hostname, 255);
+  hostname[255] = '\0';
+  g_snprintf(title, 287, "Log On to %s", hostname);
 
   /* draw login window */
-  self->login_window = xrdp_bitmap_create(400, 200, self->screen->bpp,
+  self->login_window = xrdp_bitmap_create(404, 278, self->screen->bpp,
                                           WND_TYPE_WND, self);
-  list_add_item(self->screen->child_list, (long)self->login_window);
+  list_insert_item(self->screen->child_list, 0, (long)self->login_window);
   self->login_window->parent = self->screen;
   self->login_window->owner = self->screen;
   self->login_window->bg_color = self->grey;
@@ -458,26 +418,16 @@ xrdp_login_wnd_create(struct xrdp_wm* self)
   self->login_window->top = self->screen->height / 2 -
                             self->login_window->height / 2;
   self->login_window->notify = xrdp_wm_login_notify;
-  set_string(&self->login_window->caption1, "Login to xrdp");
+  set_string(&self->login_window->caption1, title);
 
   /* image */
   but = xrdp_bitmap_create(4, 4, self->screen->bpp, WND_TYPE_IMAGE, self);
-  g_snprintf(file_path, 255, "%s/xrdp256.bmp", XRDP_SHARE_PATH);
-  xrdp_bitmap_load(but, file_path, self->palette);
-  but->parent = self->screen;
-  but->owner = self->screen;
-  but->left = self->screen->width - but->width;
-  but->top = self->screen->height - but->height;
-  list_add_item(self->screen->child_list, (long)but);
-
-  /* image */
-  but = xrdp_bitmap_create(4, 4, self->screen->bpp, WND_TYPE_IMAGE, self);
-  g_snprintf(file_path, 255, "%s/ad256.bmp", XRDP_SHARE_PATH);
+  g_snprintf(file_path, 255, "%s/rdc256.bmp", XRDP_SHARE_PATH);
   xrdp_bitmap_load(but, file_path, self->palette);
   but->parent = self->login_window;
   but->owner = self->login_window;
-  but->left = 10;
-  but->top = 30;
+  but->left = 2;
+  but->top = 23;
   list_add_item(self->login_window->child_list, (long)but);
 
   /* label */
@@ -485,28 +435,38 @@ xrdp_login_wnd_create(struct xrdp_wm* self)
   list_add_item(self->login_window->child_list, (long)but);
   but->parent = self->login_window;
   but->owner = self->login_window;
-  but->left = 155;
-  but->top = 35;
-  set_string(&but->caption1, "Module");
+  but->left = 16;
+  but->top = 209;
+  set_string(&but->caption1, "Session:");
 
   /* combo */
-  combo = xrdp_bitmap_create(140, 20, self->screen->bpp, WND_TYPE_COMBO, self);
+  combo = xrdp_bitmap_create(self->login_window->width - 200, 20, self->screen->bpp, WND_TYPE_COMBO, self);
   list_add_item(self->login_window->child_list, (long)combo);
   combo->parent = self->login_window;
   combo->owner = self->login_window;
-  combo->left = 230;
-  combo->top = 35;
+  combo->left = 100;
+  combo->top = 209;
   combo->id = 6;
   combo->tab_stop = 1;
   xrdp_wm_login_fill_in_combo(self, combo);
+  for (i = 0; i < combo->string_list->count; i++)
+  {
+    char *p;
+    p = (char*)list_get_item(combo->string_list, i);
+    if (g_strncmp(p, self->client_info->program, 255) == 0)
+    {
+      combo->item_index = i;
+      break;
+    }
+  }
 
   /* button */
   but = xrdp_bitmap_create(60, 25, self->screen->bpp, WND_TYPE_BUTTON, self);
   list_add_item(self->login_window->child_list, (long)but);
   but->parent = self->login_window;
   but->owner = self->login_window;
-  but->left = 180;
-  but->top = 160;
+  but->left = self->login_window->width - 75;
+  but->top = self->login_window->height - 38;
   but->id = 3;
   set_string(&but->caption1, "OK");
   but->tab_stop = 1;
@@ -517,14 +477,14 @@ xrdp_login_wnd_create(struct xrdp_wm* self)
   list_add_item(self->login_window->child_list, (long)but);
   but->parent = self->login_window;
   but->owner = self->login_window;
-  but->left = 250;
-  but->top = 160;
+  but->left = self->login_window->width - 145;
+  but->top = self->login_window->height - 38;
   but->id = 2;
   set_string(&but->caption1, "Cancel");
   but->tab_stop = 1;
   self->login_window->esc_button = but;
 
-  /* button */
+  /* button
   but = xrdp_bitmap_create(60, 25, self->screen->bpp, WND_TYPE_BUTTON, self);
   list_add_item(self->login_window->child_list, (long)but);
   but->parent = self->login_window;
@@ -533,7 +493,7 @@ xrdp_login_wnd_create(struct xrdp_wm* self)
   but->top = 160;
   but->id = 1;
   set_string(&but->caption1, "Help");
-  but->tab_stop = 1;
+  but->tab_stop = 1; */
 
   /* labels and edits */
   xrdp_wm_show_edits(self, combo);
diff --git a/xrdp/xrdp_mm.c b/xrdp/xrdp_mm.c
index cec7177..70fa02a 100644
--- a/xrdp/xrdp_mm.c
+++ b/xrdp/xrdp_mm.c
@@ -200,12 +200,14 @@ xrdp_mm_send_login(struct xrdp_mm* self)
   int count;
   char* username;
   char* password;
+  char* exec;
   char* name;
   char* value;
 
   xrdp_wm_log_msg(self->wm, "sending login info to sesman");
   username = 0;
   password = 0;
+  exec = "";
   self->code = 0;
   count = self->login_names->count;
   for (index = 0; index < count; index++)
@@ -220,9 +222,18 @@ xrdp_mm_send_login(struct xrdp_mm* self)
     {
       password = value;
     }
+    else if (g_strcasecmp(name, "exec") == 0)
+    {
+      exec = value;
+    }
     else if (g_strcasecmp(name, "lib") == 0)
     {
-      if ((g_strcasecmp(value, "libxup.so") == 0) ||
+      if ((g_strcasecmp(value, "libdmx.so") == 0) ||
+          (g_strcasecmp(value, "dmx.dll") == 0))
+      {
+        self->code = 20;
+      }
+      else if ((g_strcasecmp(value, "libxup.so") == 0) ||
           (g_strcasecmp(value, "xup.dll") == 0))
       {
         self->code = 10;
@@ -245,15 +256,19 @@ xrdp_mm_send_login(struct xrdp_mm* self)
   index = g_strlen(password);
   out_uint16_be(s, index);
   out_uint8a(s, password, index);
+  index = g_strlen(exec);
+  out_uint16_be(s, index);
+  out_uint8a(s, exec, index);
   out_uint16_be(s, self->wm->screen->width);
   out_uint16_be(s, self->wm->screen->height);
   out_uint16_be(s, self->wm->screen->bpp);
+  out_uint16_be(s, self->wm->session->client_info->keylayout);
   s_mark_end(s);
   s_pop_layer(s, channel_hdr);
   out_uint32_be(s, 0); /* version */
   index = s->end - s->data;
   out_uint32_be(s, index); /* size */
-  rv = xrdp_mm_send(self, s->data, index);
+  rv = xrdp_mm_send(self, s->data, s->end - s->data);
   free_stream(s);
   return rv;
 }
@@ -382,6 +397,7 @@ xrdp_mm_setup_mod1(struct xrdp_mm* self)
       self->mod->server_query_channel = server_query_channel;
       self->mod->server_get_channel_id = server_get_channel_id;
       self->mod->server_send_to_channel = server_send_to_channel;
+      self->mod->server_set_login_mode = server_set_login_mode;
     }
   }
   /* id self->mod is null, there must be a problem */
@@ -428,6 +444,10 @@ xrdp_mm_setup_mod2(struct xrdp_mm* self)
       {
         g_snprintf(text, 255, "%d", 6200 + self->display);
       }
+      else if (self->code == 20) /* Xdmx */
+      {
+        g_snprintf(text, 255, "%d", 6000 + self->display);
+      }
       else
       {
         g_set_wait_obj(self->wm->pro_layer->self_term_event); /* kill session */
@@ -511,7 +531,8 @@ xrdp_mm_process_login_response(struct xrdp_mm* self, struct stream* s)
     {
       if (xrdp_mm_setup_mod2(self) == 0)
       {
-        xrdp_wm_set_login_mode(self->wm, 10);
+	if (self->wm->login_mode == 3)
+	  xrdp_wm_set_login_mode(self->wm, 10);
         self->wm->dragging = 0;
       }
     }
@@ -526,7 +547,7 @@ xrdp_mm_process_login_response(struct xrdp_mm* self, struct stream* s)
   g_tcp_close(self->sck);
   self->sck = 0;
   self->connected_state = 0;
-  if (self->wm->login_mode != 10)
+  if (self->wm->login_mode < 4)
   {
     xrdp_wm_set_login_mode(self->wm, 11);
     xrdp_mm_module_cleanup(self);
@@ -634,10 +655,11 @@ xrdp_mm_connect(struct xrdp_mm* self)
     {
       if (xrdp_mm_setup_mod2(self) == 0)
       {
-        xrdp_wm_set_login_mode(self->wm, 10);
+	if (self->wm->login_mode == 3)
+	  xrdp_wm_set_login_mode(self->wm, 10);
       }
     }
-    if (self->wm->login_mode != 10)
+    if (self->wm->login_mode < 4)
     {
       xrdp_wm_set_login_mode(self->wm, 11);
       xrdp_mm_module_cleanup(self);
@@ -1028,3 +1050,13 @@ server_send_to_channel(struct xrdp_mod* mod, int channel_id,
   wm = (struct xrdp_wm*)mod->wm;
   return libxrdp_send_to_channel(wm->session, channel_id, data, data_len);
 }
+
+/*****************************************************************************/
+int DEFAULT_CC
+server_set_login_mode(struct xrdp_mod* mod, int login_mode)
+{
+  struct xrdp_wm* wm;
+
+  wm = (struct xrdp_wm*)mod->wm;
+  return xrdp_wm_set_login_mode (wm, login_mode);
+}
diff --git a/xrdp/xrdp_painter.c b/xrdp/xrdp_painter.c
index 451f530..0593dd3 100644
--- a/xrdp/xrdp_painter.c
+++ b/xrdp/xrdp_painter.c
@@ -602,13 +602,13 @@ xrdp_painter_copy(struct xrdp_painter* self,
     y += dy;
     palette_id = 0;
     j = srcy;
-    while (j < src->height)
+    while (j < src->lines)
     {
       i = srcx;
-      while (i < src->width)
+      while (i < src->line_width)
       {
-        w = MIN(64, src->width - i);
-        h = MIN(64, src->height - j);
+        w = MIN(64, src->line_width - i);
+        h = MIN(64, src->lines - j);
         b = xrdp_bitmap_create(w, h, self->wm->screen->bpp, 0, self->wm);
         xrdp_bitmap_copy_box_with_crc(src, b, i, j, w, h);
         bitmap_id = xrdp_cache_add_bitmap(self->wm->cache, b);
diff --git a/xrdp/xrdp_types.h b/xrdp/xrdp_types.h
index 7d2b2b7..0852899 100644
--- a/xrdp/xrdp_types.h
+++ b/xrdp/xrdp_types.h
@@ -78,7 +78,8 @@ struct xrdp_mod
   int (*server_get_channel_id)(struct xrdp_mod* v, char* name);
   int (*server_send_to_channel)(struct xrdp_mod* v, int channel_id,
                                 char* data, int data_len);
-  long server_dumby[100 - 24]; /* align, 100 minus the number of server 
+  int (*server_set_login_mode)(struct xrdp_mod* v, int login_mode);
+  long server_dumby[100 - 25]; /* align, 100 minus the number of server 
                                   functions above */
   /* common */
   long handle; /* pointer to self as int */
@@ -209,6 +210,7 @@ struct xrdp_wm
   /* generic colors */
   int black;
   int grey;
+  int med_grey;
   int dark_grey;
   int blue;
   int dark_blue;
@@ -247,6 +249,7 @@ struct xrdp_wm
   /* session log */
   struct list* log;
   struct xrdp_bitmap* log_wnd;
+  struct xrdp_bitmap* log_edit;
   int login_mode;
   tbus login_mode_event;
   struct xrdp_mm* mm;
@@ -318,6 +321,8 @@ struct xrdp_bitmap
   /* for bitmap */
   int bpp;
   int line_size; /* in bytes */
+  int line_width;
+  int lines;
   int do_not_free_data;
   char* data;
   /* for all but bitmap */
@@ -356,7 +361,7 @@ struct xrdp_bitmap
 };
 
 #define NUM_FONTS 0x4e00
-#define DEFAULT_FONT_NAME "sans-10.fv1"
+#define DEFAULT_FONT_NAME "tahoma-10.fv1"
 
 /* font */
 struct xrdp_font
